// -------------------------------------------------------------------------------
// 
// 		cwCu		OvO
// 
// 				Ver 3.13b
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxLog.h"

#ifndef DX_NON_LOG

#include "DxLib.h"
#include "DxFont.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"
#include "DxUseCLib.h"
#include "DxSystem.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

LOGDATA LogData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int			ErrorLogInitialize_Native( void ) ;										// G[ot@C鏈̊ˑ

#ifndef DX_NON_PRINTF_DX

// Oo͋@\֐
static	int			RefreshLogFont( void ) ;												// OŎgpĂtHgXV
static	int			CrLog( void ) ;															// s
static	int			AddCharLog( const TCHAR *C ) ;											// ꕶ邩ׂāAKvȂs
static	int			AddLog( const TCHAR *String ) ;											// Oo
static	int			ClrLog( void ) ;														// Ȍ

#endif // DX_NON_PRINTF_DX

// vO --------------------------------------------------------------------

// G[ot@C
extern int ErrorLogInitialize( void )
{
	if( ErrorLogInitialize_Native() < 0 )
		return -1 ;

	// ^u
	LogData.ErTabNum = 0 ; 

	// ^uroXgbvtO|
	LogData.ErTabStop = FALSE ;

	// X^[g̃^CX^v擾
	LogData.LogStartTime = NS_GetNowCount() ;

	// I
	return 0 ;
}

// G[o
extern int ErrorLogAddA( const char *ErrorStr )
{
#ifdef UNICODE
	wchar_t ErrorStrW[ 1024 ] ;
	MBCharToWChar( 932, ErrorStr, ( DXWCHAR * )ErrorStrW, 1024 ) ;
	return NS_ErrorLogAdd( ErrorStrW ) ;
#else
	return NS_ErrorLogAdd( ErrorStr ) ;
#endif
}

// G[o
extern int ErrorLogAddW( const wchar_t *ErrorStr )
{
#ifdef UNICODE
	return NS_ErrorLogAdd( ErrorStr ) ;
#else
	char ErrorStrA[ 1024 ] ;
	WCharToMBChar( 932, ( DXWCHAR * )ErrorStr, ErrorStrA, 1024 ) ;
	return NS_ErrorLogAdd( ErrorStrA ) ;
#endif
}

// tG[o
extern int ErrorLogFmtAddA( const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 1024 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSPRINTF( String , FormatString , VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_STRCAT( String , "\n" ) ;

	// Oo͂
	return ErrorLogAddA( String ) ;
}

// tG[o
extern int ErrorLogFmtAddW( const wchar_t *FormatString , ... )
{
	va_list VaList ;
	wchar_t String[ 1024 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSWPRINTF( ( WORD * )String, ( WORD * )FormatString, VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_WCSCAT( String , L"\n" ) ;

	// Oo͂
	return ErrorLogAddW( String ) ;
}

// tG[o
extern int NS_ErrorLogFmtAdd( const TCHAR *FormatString , ... )
{
	va_list VaList ;
	TCHAR String[ 1024 ] ;
	int Result ;

	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_TVSPRINTF( String , FormatString , VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_TSTRCAT( String , _T( "\n" ) ) ;

	// Oo͂
	Result = DXST_ERRORLOG_ADD( String ) ;
	
	return Result ;
}


// ^u𑝂₷
extern int NS_ErrorLogTabAdd( void )
{
	LogData.ErTabNum ++ ;

	return 0 ;
}

// ^u炷
extern int NS_ErrorLogTabSub( void )
{
	if( LogData.ErTabNum != 0 ) LogData.ErTabNum -- ;

	return 0 ;
}

// ^CX^v̗Lݒ肷
extern int NS_SetUseTimeStampFlag( int UseFlag )
{
	LogData.NonUseTimeStampFlag = UseFlag != 0 ? 0 : 1 ;

	return 0 ;
}

// tOo
extern int NS_AppLogAdd( const TCHAR *String, ... )
{
	va_list VaList ;
	TCHAR StringBuf[ 1024 ] ;

	va_start( VaList, String ) ;
	_TVSPRINTF( StringBuf, String, VaList ) ;
	va_end( VaList ) ;

	return NS_ErrorLogAdd( StringBuf ) ;
}

// G[ot@Čn
extern int ErrorLogTerminate( void )
{
	// I
	return 0 ; 
}

// Ot@Cɓt邩ǂZbg
extern int NS_SetUseDateNameLogFile( int Flag )
{
	LogData.UseLogDateName = Flag ;

	// I
	return 0 ;
}

// Oo͂sۂ̃Zbg
extern int NS_SetOutApplicationLogValidFlag( int Flag )
{
	// tOZbg
	LogData.NotLogOutFlag = !Flag ;

	// I
	return 0 ;
}

// Ot@CۑfBNgpXݒ肷
extern int NS_SetApplicationLogSaveDirectory( const TCHAR *DirectoryPath )
{
	// pX̕ۑ
	_TSTRCPY( LogData.LogOutDirectory, DirectoryPath ) ;

	// I
	return 0 ;
}










#ifndef DX_NON_PRINTF_DX

// Oo͋@\֐

// O@\̏
extern int InitializeLog( void )
{
	if( IsInitializeLog() == FALSE ) return -1 ;

	// ɏĂ牽Ȃ
	if( LogData.LogInitializeFlag == TRUE ) return 0 ;

	// tO𗧂Ă
	LogData.LogInitializeFlag = TRUE ;

	// OtHg̃TCYZbg
	LogData.LogFontSize = LOG_FONTSIZE ;

	// tHg̍쐬
	LogData.LogFontHandle = -1 ;
	LogData.LogFontHandleLostFlag = TRUE ;

	// O̗L薳tOZbg
	LogData.LogDrawFlag = FALSE ;

	// Õt@Co͗L薳tOZbg
	LogData.LogFileOutFlag = FALSE ;

	// O̕Zbg
	LogData.LogTabWidth = LOG_TABWIDTH ;

	// J[\̈ʒuZbg
	LogData.LogX = LogData.LogY = 0 ;

	// XgO
	_MEMSET( LogData.LogString, 0, sizeof( LogData.LogString ) ) ;

	// I
	return 0 ;
}

// Ǒns
extern int TerminateLog( void )
{
	// OĂȂȂɂȂ
	if( LogData.LogInitializeFlag == FALSE ) return 0 ;

	// tHgnh폜
	if( LogData.LogFontHandleLostFlag == FALSE )
	{
		NS_DeleteFontToHandle( LogData.LogFontHandle ) ;
	}
	LogData.LogFontHandleLostFlag = TRUE ;
	LogData.LogFontHandle = -1 ;

	// tO|
	LogData.LogInitializeFlag = FALSE ;

	// I
	return 0 ;
}

// OŎgpĂtHgXV
static int RefreshLogFont( void )
{
	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	if( LogData.LogFontHandleLostFlag == FALSE ) return 0 ;

	// tHgnh쐬
	CREATEFONTTOHANDLE_GPARAM GParam ;
	InitCreateFontToHandleGParam( &GParam ) ;
	LogData.LogFontHandle = CreateFontToHandle_UseGParam( &GParam, NULL, LogData.LogFontSize, LOG_FONTTICK, DX_FONTTYPE_EDGE, -1, -1, FALSE, -1, FALSE ) ;
	if( LogData.LogFontHandle >= 0 )
	{
		// tHgnh폜ꂽۂɗtÕ|C^Zbg
		LogData.LogFontHandleLostFlag = FALSE ;
		NS_SetFontLostFlag( LogData.LogFontHandle, &LogData.LogFontHandleLostFlag  ) ;
	}

	return 0 ;
}

// s
static int CrLog( void )
{
	int ScWidth, ScHeight, StrHeight ;

	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ʂ̃TCY擾
	NS_GetDrawScreenSize( &ScWidth , &ScHeight ) ;
	
	// ʓɎ܂sZo
	StrHeight = ScHeight / LogData.LogFontSize ;
	if( StrHeight > LOG_MAXHEIGHT ) StrHeight = LOG_MAXHEIGHT ;

	// sʂOĂ܂ȂׁAO邩ǂŏ𕪊
	if( StrHeight <= LogData.LogY + 1 )
	{
		// Oꍇ͈sf[^Sďグ

		// Ps炷
		_MEMMOVE( LogData.LogString[0], LogData.LogString[1], sizeof( TCHAR ) * LOG_MAXLENGTH * LogData.LogY ) ;
	}
	else
	{
		// xWCNg
		LogData.LogY ++ ;
	}

	// Vs̕
	_MEMSET( LogData.LogString[ LogData.LogY ], 0, sizeof( TCHAR ) * LOG_MAXLENGTH ) ;

	// `敝
	LogData.LogDrawWidth = 0 ;

	// wW
	LogData.LogX = 0 ;

	// I
	return 0 ;
}

// ꕶOɒǉAKvȂs
static int AddCharLog( const TCHAR *C )
{
	int ScWidth, ScHeight ;
	int Width = 0, Length, i ;

	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ʂ̃TCY擾
	NS_GetDrawScreenSize( &ScWidth , &ScHeight ) ;

	// V̕`敝擾
//	Length = _mbclen( (unsigned char *)C ) ;
	if( _TMULT( *C, _GET_CODEPAGE() ) == TRUE )	Length = 2 ;
	else										Length = 1 ;

	// 񂪃obt@I[o[ȂׂAoꍇ͉s
	if( LogData.LogX + Length >= LOG_MAXLENGTH )
	{
		CrLog() ;
	}
	else
	{
		// ʊOɏoȂׂAoꍇ͉s
		Width = NS_GetDrawStringWidthToHandle( C , Length , LogData.LogFontHandle ) ;
		if( Width + LogData.LogDrawWidth >= ScWidth ) 
		{
			CrLog() ;
		}
	}

	// `敝Z
	LogData.LogDrawWidth += Width ;

	// ǉ
	for( i = 0 ; i < Length ; i ++ )
	{
		LogData.LogString[ LogData.LogY ][ LogData.LogX + i ] = C[ i ]  ;
	}
	LogData.LogString[ LogData.LogY ][ LogData.LogX + i ] = _T( '\0' ) ;

	// J[\ʒuCNg
	LogData.LogX += Length  ;

	// I
	return Length ;
}


// Oo
static int AddLog( const TCHAR *String )
{
	int StrLen ;

	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ꕶÂǉĂ
	{
		int i ;
		const TCHAR *C ;

		// r؂܂ŌJԂ
		StrLen = lstrlen( String ) ;
		for( i = 0 ; i < StrLen ; i ++ )
		{
			C = &String[ i ] ;

			// ̃̕^Cvɂď𕪊
			switch( *C )
			{
			case _T( '\n' ) :
				// sR[h̏ꍇ͉ss
				CrLog() ;
				break ;

			case _T( '\t' ) :
				{
					int j ;

					// ^ȕꍇ̓^u̕Xy[Xǉ
					for( j = 0 ; j < LogData.LogTabWidth ; j ++ )
						AddCharLog( _T( " " ) )  ;
				}
				break ;

			case _T( '\a' ) : case _T( '\b' ) : case _T( '\?' ) : 
			case _T( '\f' ) : case _T( '\r' ) : case _T( '\v' ) :
				break ;

			default :
				// ȊȌꍇ͕ʂɒǉ
				if( AddCharLog( C ) == 2 ) i ++ ;
				break ;
			}
		}
	}

	// I
	return 0 ;
}

// Ȍ
static int ClrLog( void )
{
	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// O
	_MEMSET( LogData.LogString, 0, sizeof( LogData.LogString ) ) ;

	// J[\ʒu
	LogData.LogX = LogData.LogY = 0 ;
	LogData.LogDrawWidth = 0 ;

	// I
	return 0 ;
}

// Oo̓tOZbg
extern int NS_SetLogDrawOutFlag( int DrawFlag )
{
	// O`o̓tOZbg
	LogData.LogDrawFlag = DrawFlag ;

	// I
	return 0 ;
}

// Oo͂邩tO̎擾
extern int NS_GetLogDrawFlag( void )
{
	return LogData.LogDrawFlag ;
}

// printfDx ŉʂɏo͂郍OtHg̃TCYύX
extern int NS_SetLogFontSize( int Size )
{
	if( Size < 0 ) Size = LOG_FONTSIZE;

	LogData.LogFontSize = Size;

	DeleteFontToHandle( LogData.LogFontHandle );
	LogData.LogFontHandle = -1;
	LogData.LogFontHandleLostFlag = TRUE;

	RefreshLogFont();

	// I
	return 0;
}

// O`悷
extern int DrawLog( void )
{
	int ScWidth , ScHeight ;
	int StrHeight , i ;

	if( LogData.LogInitializeFlag == FALSE )
		if( InitializeLog() < 0 ) return 0 ;

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ʂ̃TCY擾
	NS_GetDrawScreenSize( &ScWidth , &ScHeight ) ;
	
	// ʂɃO`悷
	StrHeight = ScHeight / LogData.LogFontSize  ;
	if( StrHeight >= LOG_MAXHEIGHT ) StrHeight = LOG_MAXHEIGHT ;
	for( i = 0 ; i < StrHeight ; i ++ )
	{
		NS_DrawStringToHandle( 0 , i * LogData.LogFontSize , LogData.LogString[ i ] , NS_GetColor( 255 , 255 , 255 ) , LogData.LogFontHandle , NS_GetColor( 0 , 0 , 0 ) ) ;
	}

	// I
	return 0 ;
}








// ȈՉʏo͊֐
extern int NS_printfDx( const TCHAR *FormatString , ... )
{
	va_list VaList ;
	TCHAR String[ 1024 ] ;
	int Result ;

	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_TVSPRINTF( String , FormatString , VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// Oo̓tO𗧂Ă
	LogData.LogDrawFlag = TRUE ;

	// Oo͊֐Ă
	Result = AddLog( String ) ;

	// I
	return Result ;
}

// ȈՉʏo͂NA
extern int NS_clsDx( void )
{
	// O
	ClrLog() ;

	// Oo̓tO|
	LogData.LogDrawFlag = FALSE ;

	// I
	return 0 ;
}

#endif // DX_NON_PRINTF_DX


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_LOG

